// SScreenMode.cpp: Implementierung der Klasse SScreenMode.
//
// Copyright by Andr Stein
// E-Mail: andre_stein@gmx.de, andre_stein@web.de
// http://stonemaster.port5.com
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "SScreenMode.h"


//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SScreenMode::SScreenMode()
{
	screenModeSet = false;
}

SScreenMode::~SScreenMode()
{
	reset();
}

SScreenMode::SScreenMode(int width, int height, int bpp)
{
	if (!setDisplayMode(width, height, bpp))
	{
		return;
	}
}

//////////////////////////////////////////////////////////////////////
// Funktionen
//////////////////////////////////////////////////////////////////////

bool SScreenMode::setDisplayMode(int width, int height, int bpp)
{
	DEVMODE displayMode;

	memset(&displayMode, 0 , sizeof(displayMode));

	displayMode.dmSize          = sizeof(displayMode);		
	displayMode.dmPelsWidth	    = width;			
	displayMode.dmPelsHeight	= height;	
	displayMode.dmBitsPerPel	= bpp;		
	displayMode.dmFields        =  DM_BITSPERPEL | 
								   DM_PELSWIDTH  |
								   DM_PELSHEIGHT;

	//Speichert die jetzige Bildschirmauflsung
	EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &savedMode);

	if (ChangeDisplaySettings(&displayMode , CDS_FULLSCREEN)
		!= DISP_CHANGE_SUCCESSFUL)
	{
		return false;
	}
	
	screenModeSet = true;

	return true;
}

void SScreenMode::reset()
{
	if (!screenModeSet)
	{
		return;
	}

	if (!ChangeDisplaySettings(NULL,CDS_TEST)) 
	{ 		
		ChangeDisplaySettings(NULL,CDS_RESET);		 
		ChangeDisplaySettings(&savedMode,CDS_RESET);	
	}
	else 
	{
		ChangeDisplaySettings(NULL,CDS_RESET);		
	}

	screenModeSet = false;
}


